'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = createReducer;

var _actions = require('./actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createReducer(_ref, extendReducer) {
    var _extends2;

    var name = _ref.name,
        projection = _ref.projection;

    var handlers = _extends((_extends2 = {}, _defineProperty(_extends2, _actions.MERGE_STATE, function (state, _ref2) {
        var readModelName = _ref2.readModelName,
            actionState = _ref2.state;

        if (readModelName === name) {
            return state.merge(actionState);
        }
        return state;
    }), _defineProperty(_extends2, _actions.REPLACE_STATE, function (state, _ref3) {
        var readModelName = _ref3.readModelName,
            actionState = _ref3.state;

        if (readModelName === name) {
            return actionState;
        }
        return state;
    }), _extends2), projection);

    return function () {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        var action = arguments[1];

        var eventHandler = handlers[action.type];

        if (eventHandler) {
            return eventHandler(state, action);
        }

        if (extendReducer) {
            return extendReducer(state, action);
        }

        return state;
    };
}