'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

require('regenerator-runtime/runtime');

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var sendCommandDefault = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(command) {
        var response, text;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return (0, _isomorphicFetch2.default)((0, _util.getRootableUrl)('/api/commands'), {
                            method: 'POST',
                            headers: { 'Content-Type': 'application/json' },
                            credentials: 'same-origin',
                            body: JSON.stringify(command)
                        });

                    case 2:
                        response = _context.sent;

                        if (!response.ok) {
                            _context.next = 5;
                            break;
                        }

                        return _context.abrupt('return', response.blob());

                    case 5:
                        _context.next = 7;
                        return response.text();

                    case 7:
                        text = _context.sent;

                        // eslint-disable-next-line no-console
                        console.error('Send command error:', text);
                        return _context.abrupt('return', Promise.reject(text));

                    case 10:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function sendCommandDefault(_x) {
        return _ref.apply(this, arguments);
    };
}();

exports.default = function () {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return function (store) {
        return function (next) {
            return function (action) {
                var command = action.command,
                    aggregateId = action.aggregateId,
                    aggregateName = action.aggregateName,
                    payload = action.payload;


                var sendCommand = params.sendCommand ? params.sendCommand : sendCommandDefault;

                if (command && (0, _util.checkRequiredFields)({ aggregateId: aggregateId, aggregateName: aggregateName }, 'Send command error:', JSON.stringify(action)) && !command.error) {
                    var normalizedCommand = {
                        type: command.type,
                        aggregateId: aggregateId,
                        aggregateName: aggregateName,
                        payload: payload
                    };

                    sendCommand(normalizedCommand, store.dispatch).catch(function (error) {
                        store.dispatch(_extends({}, action, {
                            command: _extends({}, action.command, {
                                error: error
                            })
                        }));
                    });
                }

                return next(action);
            };
        };
    };
};